{$A-,B-,D-,E-,F-,I-,L-,N-,O-,R-,S+,V-}
unit UniPascal; interface

  type Cardinal  = word;
       ShortCard = byte;
       Natural	 = 0..MaxInt;
       LongWord  = LongInt;
       Real	 = Single;

  function HiWord(IntValue: longint): word;	    { Return the high word }
  inline($58		{ pop ax	}	    { from a long integer  }
	/$58);		{ pop ax	}

  function LoWord(IntValue: longint): word;	    { Return the low word }
  inline($58		{ pop ax	}	    { from a long integer }
	/$5A);		{ pop dx	}

  function LongSwap(l: LongInt): LongWord;

  procedure FillWord(var Dest; Count, Filler : Word);
    {-Fill memory starting at Dest with Count instances of Filler}
    inline(
      $58/                     {pop ax    ;AX = Filler}
      $59/                     {pop cx    ;CX = Count}
      $5F/                     {pop di    ;ES:DI => Dest}
      $07/                     {pop es}
      $FC/                     {cld       ;go forward}
      $F2/$AB);                {rep stosw ;fill memory}

  procedure MoveWords(var src, dest; size: cardinal);
  function Byte2Str(b: byte): string;
  function Word2Str(w: word): string;
  function Lword2Str(l: longint): string;

  procedure ParamStr(n: byte; var s: string);

  procedure getmemwords(var p: pointer; size: cardinal);

implementation

  procedure getmemwords(var p: pointer; size: cardinal);
  begin
    getmem(p, size*2);
  end { getmemwords };

  function LongSwap(L: LongInt): longword;
  begin
  longswap:= LongInt(swap(LoWord(l)) * 65536 +  swap(HiWord(l)));
  end { longSwap };

  const hexs: packed array [0..15] of char = '0123456789abcdef';

  function Byte2Str(b: byte): string;
  begin
    Byte2Str:= hexs[b div 16] + hexs[b mod 16];
  end { Byte2Str };

  function Word2Str(w: word): string;
  begin
    Word2Str:= Byte2Str(hi(w)) + Byte2Str(lo(w));
  end { Word2Str };

  function Lword2Str(l: longint): string;
  begin
    Lword2Str:= Word2Str(hiword(l)) + Word2Str(loword(l));
  end { Lword2Str };

  procedure MoveWords(var src, dest; size: cardinal);
  begin
    move(src, dest, size*2);
  end { movewords };

  procedure ParamStr(n: byte; var s: string);
  begin
    s:= system.paramstr(n);
  end { ParamStr };

end { UniPascal }.